import React, { createContext, useContext, useState, useEffect } from "react";
import useInterval from "../lib/useInterval";
const initialState = {
  areaInfo: "",
  setAreainfo: () => {},
  areaIconBadgeText: "",
};

const AreaInfoContext = createContext(initialState);

export const useAreaInfo = () => {
  return useContext(AreaInfoContext);
};

const areaStationPair = {
  seto: ["Y"],
  yosan1: ["Y"],
  yosan2: ["U"],
  dosan1: ["D"],
  dosan2: ["K"],
  kotoku: ["T"],
  mugi: ["M"],
  tokushima: ["B"],
  naruto: ["N"],
  yodo: ["G"],
};
export const AreaInfoProvider = ({ children }) => {
  const [areaInfo, setAreaInfo] = useState("");
  const [areaIconBadgeText, setAreaIconBadgeText] = useState("");
  const getAreaData = () => {
    fetch(
      "https://script.google.com/macros/s/AKfycbz80LcaEUrhnlEsLkJy0LG2IRO3DBVQhfNmN1d_0f_HvtsujNQpxM90SrV9yKWH_JG1Ww/exec"
    )
      .then((d) => d.text())
      .then((d) => setAreaInfo(d));
    fetch("https://n8n.haruk.in/webhook/jr-shikoku-trainfo-flag")
      .then((d) => d.json())
      .then((d) => {
        if (!d.data) return;
        const text = d.data
          .filter((e) => e.status)
          .map((e) => `${areaStationPair[e.area].join("")}`);
        setAreaIconBadgeText(text.length == 0 ? "!" : text.join(","));
      });
  };
  useEffect(getAreaData, []);
  useInterval(getAreaData, 60000); //60秒毎に全在線列車取得
  return (
    <AreaInfoContext.Provider
      value={{ areaInfo, setAreaInfo, areaIconBadgeText }}
    >
      {children}
    </AreaInfoContext.Provider>
  );
};
